<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="88px">
      <el-form-item label="吊钩编号" prop="hookNo">
        <el-input
          v-model="queryParams.hookNo"
          placeholder="请输入吊钩编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="芯片编号" prop="epcNo">
        <el-input
          v-model="queryParams.epcNo"
          placeholder="请输入芯片编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['app:hookRegister:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['app:hookRegister:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border stripe  v-loading="loading" :data="hookList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55"  />
      <!--  <el-table-column label="ID"  prop="id" width="80" />  -->
      <el-table-column label="吊钩编号"  prop="hookNo" width="100" />
      <el-table-column label="芯片编号"  prop="epcNo" />
      <el-table-column label="操作"  width="180" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="handleView(scope.row)"
            >查看</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['app:hookRegister:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['app:hookRegister:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改吊钩对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" :disabled="isView" label-width="120px">
        <el-form-item label="吊钩编号" prop="hookNo">
          <el-input v-model="form.hookNo" placeholder="请输入吊钩编号" />
        </el-form-item>
        <el-form-item label="芯片编号" prop="epcNo">
          <el-input v-model="form.epcNo" placeholder="请输入芯片编号"  />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listHookRegister, getHookRegister, delHookRegister, addHookRegister, updateHookRegister } from "@/api/app/hookRegister";
import {patchZero} from "@/utils/str.js"
export default {
  name: "HookRegister",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 吊钩表格数据
      hookList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        hookNo: null,
        epcNo: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        hookNo: [
          { required: true, message: "吊钩编号不能为空", trigger: "blur" },
          {
              pattern: /^\d{1,4}$/,
              message: '吊钩编号超出最大长度限制（4位数字）',
              trigger: 'blur'
          },
        ],
        epcNo: [
          { required: true, message: "芯片编号不能为空", trigger: "blur" },
          {
              pattern: /^[a-zA-Z0-9]{24}$/,
              message: '芯片编号输入限制24位数字或字母',
              trigger: 'blur'
          },
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询吊钩列表 */
    getList() {
      // this.loading = false;
      this.loading = true;
      listHookRegister(this.queryParams).then(response => {
        this.hookList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        hookNo: null,
        epcNo: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加吊钩与芯片绑定";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getHookRegister(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.isView = false;
        this.title = "修改吊钩与芯片绑定";
      });
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id || this.ids
      getHookRegister(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.isView = true;
        this.title = "查看吊钩与芯片绑定";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.form.hookWeight = this.form.hookWeight?parseFloat(this.form.hookWeight).toFixed(2):0;
      this.$refs["form"].validate(valid => {
        if (valid) {
          if(this.form.hookNo){
            this.form.hookNo = patchZero(this.form.hookNo,4);
          }
          if (this.form.id != null) {
            updateHookRegister(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addHookRegister(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除吊钩编号为"' + ids + '"的数据项？').then(function() {
        return delHookRegister(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
  }
};
</script>
